#include <stdio.h>
#include <string.h>
#include "graph.h"
/*----------------------------------------------------------------------------*/
typedef struct tagBITMAPFILEHEADER {    /* bmfh */
	long	bfSize;
	long	bfReserved;
	long	bfOffBits;
	long	biSize;
	long	biWidth;
	long	biHeight;
	long	biPlanes_biBitCount;
	long	biCompression;
	long	biSizeImage;
	long	biXPelsPerMeter;
	long	biYPelsPerMeter;
	long	biClrUsed;
	long	biClrImportant;
} BITMAPINFOHEADER;
/*----------------------------------------------------------------------------*/
typedef struct tagRGBQUAD {     /* rgbq */
	char	rgbBlue;
	char	rgbGreen;
	char	rgbRed;
	char	rgbReserved;
} RGBQUAD;
/*----------------------------------------------------------------------------*/
BITMAPINFOHEADER bmp_header =
{
	0,
	0,
	1078,
	40,
	0,
	0,
	0x00080001,
	0,
	0,
	0,
	0,
	0,
	0
};
/*----------------------------------------------------------------------------*/
void bmp_save(char *filename, grBitmap *bit, long w)
{
	int i;
	FILE *fp;
	int bmp_size;
	unsigned char *b;

	if( w<1 )
		w = 1;
	else
	if( w > bit->width )
		w = bit->width;
	bmp_size = w * bit->rows;
	bmp_header.bfSize = 2 + sizeof(bmp_header) + bmp_size + 1024;
	bmp_header.biWidth = w;
	bmp_header.biHeight = -bit->rows;
	bmp_header.biSizeImage = bmp_size;

	fp = fopen(filename, "w");
	fwrite("BM", 2, 1, fp);
	fwrite(&bmp_header, sizeof(bmp_header), 1, fp);
	for( i=0; i<256; i++ ) {
		RGBQUAD c = { i, i, i, 0 };
		fwrite(&c, sizeof(c), 1, fp);
	}
	b = bit->buffer;
	if( w % 4 ) w += (4 - (w % 4));
	for( i=0; i<bit->rows; i++ ) {
		fwrite(b, w, 1, fp);
		b += bit->width;
	}
	fclose(fp);
}
/*----------------------------------------------------------------------------*/
